# How to contribute to Application Engine

Application Engine is a platform to develop quickly low-code applications written in Petriflow language. Application
Engine (NAE for short) is based on Spring framework with fully complaint Petriflow language interpreter.

## Ways you can contribute

First, make sure you've read the [code of conduct](CODE_OF_CONDUCT.md). TL;DR: be excellent to each other. Be calm, be
kind, help make engine a community where new faces feel welcome and old hands feel appreciated.

* Report a bug. If you've found something that does not work or does not make sense, let us know.
* Suggest a new feature.
* Suggest improvements to the platform.

### Reporting bugs

If you've found a bug, let us know about it.

* Search the [Issues](https://github.com/netgrif/application-engine/issues) to check we're not already tracking it.
* If you can't find an open issue that describes your
  problem, [open a new one](https://github.com/netgrif/application-engine/issues/new).
    * Include a **title and clear description**
    * Describe:
        * What you did (ideally with a code sample or executed steps)
        * What you expected to happen
        * What actually happened, including any error messages or program output.
        * Include the version of the platform and environment that you used to run the engine.

### Contributing Features

If you've got a great idea for the engine feature, start by checking
[issues](https://github.com/netgrif/application-engine/labels/improvement) to check we're not already tracking it, or
that your idea hasn't already been rejected.

If not, start by [opening an issue](https://github.com/netgrif/application-engine/issues/new) that describes your idea.
Do not be afraid of rejection, every excellent idea has to start somewhere. Give it a well described solution to the
problem which your proposition is trying to solve.